
class Attribute:
  '''
  Arbitrary information which can be attached to a tree vertex
  Attribute should be subclassed for each specific kind of information
  '''
  
  def __init__(self, obj):
    '''
    Arbitrary information which can be attached to a tree vertex
    Attribute should be subclassed for each specific kind of information
    '''
    self.obj = obj
  
  def __eq__(self, obj):
    if not hasattr(obj, 'obj'):
      return 0
    return self.isSame(obj)
  
  def __getattr__(self, attr):
    '''
    Every call to the interface is dispatched to the underlying class
    '''
    return getattr(self.obj, attr)
  
  def weakReference(self):
    return self
